#include "monster.h"

#define NUMMONSTERS 415

struct Image
	{
	BYTE numColors;
	int mold;
	BYTE size;			//0 = 64x64 1 = 128x128
	WORD ROMsize;
	int offset;
	bool used;

	BYTE *graphicsData;
	};
	
class Monsters
	{	
	public:
	
	RGBTRIPLE monsPals[768][8];
	
	Image image[450];

	friend class Monster;

	Monsters(void);
	
	void cleanup(void);
	void compress(void);
	int getFreeRoom(void);
	Monster* getMonster(int);
	bool loadMonsters(char*);
	bool saveMonsters(char*);
	void updateMonsters(void);
	
	//Inline functions

	inline int getNumImages(void)
		{ return numMonsImages; }

	private:

	Monster monster[415];

	BYTE *molds8;
	BYTE *molds16;
	int numMolds8;
	int numMolds16;

	int numMonsImages;

	BYTE *graphics;
	BYTE *moldData;

	int maxTileSize;
	int maxMoldSize;

	long calcROMSize(void);
	bool imageUsed(int);
	bool moldUsed(int,BYTE);
	void loadMonsGraphics(int);
	void loadMonsPals(int);
	void loadMonsNames(int);
	void loadMonsMolds(int);
	void removeImage(int);
	void removeMold(int,BYTE);
	void saveMolds(int);
	void savePals(int);
	void saveSpecs(int);
	void saveTiles(int);
	
	};

int numTiles(BYTE *,BYTE);
bool moldcmp(BYTE *,BYTE *,BYTE);

extern Monsters monsters;

